Smart.Scheduler Menus

Scheduler for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { SchedulerComponent, SchedulerModule } from 'smart-webcomponents-angular/scheduler';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, SchedulerModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('scheduler', { read: SchedulerComponent, static: false }) scheduler!: SchedulerComponent;
}
<!-- app.component.html -->
<smart-scheduler #scheduler></smart-scheduler>

Use this.scheduler for API methods in this topic.

Menus

Smart.Scheduler contains many clickable elements some of which can trigger a popup menu to appear. Depending on the click target the popup can be for date selection, view selection, event editing/creation or a context menu.

A Smart.Tooltip component is used for the menus of the Smart.Scheduler. It has the abbility to reposition itself in order to always be inside the visible area.

Here is a list of the Smart.Scheduler menus:

Date Menu

The Scheduler always shows a date or a range of dates depending on the view. For example, when the view is set to 'day' only one date can be visible. The currently visible date is determined by the dateCurrent property of the Smart.Scheduler. It can be changed via the Date Menu which can be triggered from the date selection control that is located in the header.

When the date selector is clicked the Date Menu appears under it by displaying a Smart.Calendar that allows to pick the view date.

There are two events related to the Date Menu in the Smart.Scheduler:

  • dateMenuOpen - fired when the Date Menu is opened.
  • dateMenuClose - fired when the Date Menu is closed.

Here's how to bind to the events:

this.scheduler.addEventListener('dateMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The Date Menu can be disabled by setting the disableDateMenu property of the Smart.Scheduler.

View Menu

The View Menu is the default choice for view selection. In order to change the current view simply click on the view selector control which is positioned inside the header of the Smart.Scheduler component and the View Menu will open.

However the usage of the View Menu depends on the viewSelectorType property. This property determines whether the view items are positioned inside a menu or as tabs. A third option is also available called 'auto' that allows the Scheduler to automatically determine when to use a menu or tabs control for view selection. The decision is based on the space available inside the header for the views. When the view selector type is set to 'tabs', two additional navigation buttons appear in the view selection area that allow to scroll through the items when necessary.

When the View selector button is clicked the View Menu will appear:

The View Menu items depend on the views property. The views defined in the views property will appear as view items in the View Menu. Custom views can be defined as objects. These views can have custom labels and custom shortcut keys as well.

At the bottom of the View menu there's an additional checkbox item that allows to show/hide the weekends. This property depends on the current view settings. It also depends on the hideWeekend Smart.Scheduler property which hides the weekends for all views. However this property can be applied to specific views as well.

Another cool feature of the View Menu is the view items shortcuts. By default each view item has a shortcut key or key combination that when executed the Smart.Sheduler will switch to the corresponding view. The View seletor button should be focused in order for the shortcuts to work. By default the buttons is focused while the View Menu is opened. These shortcuts can also be modifed in the custom view object definition via the views property. Here's an example of a custom view:

componentOptions = {
            //Properties
            view: 'month',
            nonworkingDays: [0, 3],
            views: [
                {
                    type: 'month',
                    label: 'Custom Month',
                    hideNonworkingWeekdays: true,
                    shortcutKey: 'X'
                },
                {
                    type: 'week',
                    label: 'Custom Week',
                    shortcutKey: 'C+W'
                },
                {
                    type: 'agenda',
                    label: 'Custom Agenda',
                    hideWeekend: true,
                    shortcutKey: 'C+A'
                },
            ]
}; 

There are two events related to the View Menu in the Smart.Scheduler:

  • viewMenuOpen - fired when the View Menu is opened.
  • viewMenuClose - fired when the View Menu is closed.

Here's how to bind to the events:

this.scheduler.addEventListener('viewMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The View Menu can be disabled by setting the disableViewMenu property of the Smart.Scheduler.

Context Menu

Smart.Scheduler has a build in Context Menu that appears on mouse right click (or touch hold for mobile) over a view cell or an event element. The Context Menu contains menu items. Each item has a label and a value. The label is used as the name of the item wihle value represents the action. Smart.Scheduler has two build-in context menu actions: 'createEvent' and 'editEvent'. The items are determined based on the click target. For example 'editEvent' action is only showed when the user opens the Context Menu on events, not on cells. The view cell Context Menu is only used to create new events.

The Context Menu can be customized to contain completely different items that execute other user actions thanks to the contextMenuDataSource property. It accepts an Array of objects with label-value pairs where the label is again used to name the item and value for the action. The Smart.Scheduler will only create the custom context menu items while the custom action handling is left to the user.

Here's how the Context Menu for a view cell appears when opened:

and here's how the Context Menu for an event element appears when opened:

Clicking on one of the items in the default Context Menu will trigger the Scheduler Window to create/edit an event.

The following events are triggered by the Context Menu:

  • contextMenuOpen - fired when the Context Menu is opened.
  • itemClick - fired when a Context Menu Item was clicked. This event contains details regarding the item that is clicked.
  • contextMenuClose - fired when the Context Menu is closed.

Here's how to bind to the events:

this.scheduler.addEventListener('contextMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The Context Menu can be disabled by setting the disableContextMenu property to the Smart.Scheduler.

An additional contextMenuClipboardActions boolean property is available that if enabled displays the 'Copy/Cut/Paste' clipboard shortut items as part of the default context menu.

Event Menu

Events inside the Smart.Scheduler timeline can trigger a menu that shows additional information for the target event.

The event information is shown as a Event Menu item. These items actually represent the event objects that correspond to the clicked target but have an additional button that allows to directly delete the event without going through the Scheduler Window.

If an Event Menu item is clicked then the Smart.Scheduler Window will appear allowing to modify the target event.

Here's what the Event Menu looks like for Scheduler timeline events when clicked:

When the click target is an event collector then the Event Menu contains a list of events that are collected. The Event Menu represent a Smart.ScrollViewer and if the events overflow a scrollbar will appear allowing to scroll through them:

The following events are triggered by the Event Menu:

  • eventMenuOpen - fired when the Event Menu is opened.
  • itemClick - fired when a Event Menu Item is clicked. This event contains details regarding the item that was clicked.
  • eventMenuClose - fired when the Event Menu is closed.

Here's how to bind to the events:

this.scheduler.addEventListener('eventMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

Event Menu for specific events can be triggered via the Smart.Scheduler API as well thanks to the following methods:

  • openEventTooltip - opens the Event Menu for specific event if possible. The method takes one argument - a Scheduler event object:
    openEventTooltip(eventObj:EventObj)
  • closeEventTooltip - closes the Event Menu if opened.
    closeEventTooltip()

The Event Menu can be disabled by setting the disableEventMenu property to the Smart.Scheduler.

Smart.Scheduler menus can be styled via CSS variables. Check the Smart.Scheduler API for more details on CSS styling.

For AI tooling

Developer Quick Reference

Topic: scheduler-menus   Component: Scheduler   Framework: Angular

Main methods: (none detected)

Common config keys: views

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.

Smart.Scheduler Menus

Scheduler for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Scheduler } from 'smart-webcomponents-react/scheduler';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Scheduler ref={componentRef} {...componentProps}></Scheduler>;
}

Use componentRef.current for API methods in this topic.

Menus

Smart.Scheduler contains many clickable elements some of which can trigger a popup menu to appear. Depending on the click target the popup can be for date selection, view selection, event editing/creation or a context menu.

A Smart.Tooltip component is used for the menus of the Smart.Scheduler. It has the abbility to reposition itself in order to always be inside the visible area.

Here is a list of the Smart.Scheduler menus:

Date Menu

The Scheduler always shows a date or a range of dates depending on the view. For example, when the view is set to 'day' only one date can be visible. The currently visible date is determined by the dateCurrent property of the Smart.Scheduler. It can be changed via the Date Menu which can be triggered from the date selection control that is located in the header.

When the date selector is clicked the Date Menu appears under it by displaying a Smart.Calendar that allows to pick the view date.

There are two events related to the Date Menu in the Smart.Scheduler:

  • dateMenuOpen - fired when the Date Menu is opened.
  • dateMenuClose - fired when the Date Menu is closed.

Here's how to bind to the events:

componentRef.current.addEventListener('dateMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The Date Menu can be disabled by setting the disableDateMenu property of the Smart.Scheduler.

View Menu

The View Menu is the default choice for view selection. In order to change the current view simply click on the view selector control which is positioned inside the header of the Smart.Scheduler component and the View Menu will open.

However the usage of the View Menu depends on the viewSelectorType property. This property determines whether the view items are positioned inside a menu or as tabs. A third option is also available called 'auto' that allows the Scheduler to automatically determine when to use a menu or tabs control for view selection. The decision is based on the space available inside the header for the views. When the view selector type is set to 'tabs', two additional navigation buttons appear in the view selection area that allow to scroll through the items when necessary.

When the View selector button is clicked the View Menu will appear:

The View Menu items depend on the views property. The views defined in the views property will appear as view items in the View Menu. Custom views can be defined as objects. These views can have custom labels and custom shortcut keys as well.

At the bottom of the View menu there's an additional checkbox item that allows to show/hide the weekends. This property depends on the current view settings. It also depends on the hideWeekend Smart.Scheduler property which hides the weekends for all views. However this property can be applied to specific views as well.

Another cool feature of the View Menu is the view items shortcuts. By default each view item has a shortcut key or key combination that when executed the Smart.Sheduler will switch to the corresponding view. The View seletor button should be focused in order for the shortcuts to work. By default the buttons is focused while the View Menu is opened. These shortcuts can also be modifed in the custom view object definition via the views property. Here's an example of a custom view:

const componentProps = useMemo(() => ({
            //Properties
            view: 'month',
            nonworkingDays: [0, 3],
            views: [
                {
                    type: 'month',
                    label: 'Custom Month',
                    hideNonworkingWeekdays: true,
                    shortcutKey: 'X'
                },
                {
                    type: 'week',
                    label: 'Custom Week',
                    shortcutKey: 'C+W'
                },
                {
                    type: 'agenda',
                    label: 'Custom Agenda',
                    hideWeekend: true,
                    shortcutKey: 'C+A'
                },
            ]
}), []); 

There are two events related to the View Menu in the Smart.Scheduler:

  • viewMenuOpen - fired when the View Menu is opened.
  • viewMenuClose - fired when the View Menu is closed.

Here's how to bind to the events:

componentRef.current.addEventListener('viewMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The View Menu can be disabled by setting the disableViewMenu property of the Smart.Scheduler.

Context Menu

Smart.Scheduler has a build in Context Menu that appears on mouse right click (or touch hold for mobile) over a view cell or an event element. The Context Menu contains menu items. Each item has a label and a value. The label is used as the name of the item wihle value represents the action. Smart.Scheduler has two build-in context menu actions: 'createEvent' and 'editEvent'. The items are determined based on the click target. For example 'editEvent' action is only showed when the user opens the Context Menu on events, not on cells. The view cell Context Menu is only used to create new events.

The Context Menu can be customized to contain completely different items that execute other user actions thanks to the contextMenuDataSource property. It accepts an Array of objects with label-value pairs where the label is again used to name the item and value for the action. The Smart.Scheduler will only create the custom context menu items while the custom action handling is left to the user.

Here's how the Context Menu for a view cell appears when opened:

and here's how the Context Menu for an event element appears when opened:

Clicking on one of the items in the default Context Menu will trigger the Scheduler Window to create/edit an event.

The following events are triggered by the Context Menu:

  • contextMenuOpen - fired when the Context Menu is opened.
  • itemClick - fired when a Context Menu Item was clicked. This event contains details regarding the item that is clicked.
  • contextMenuClose - fired when the Context Menu is closed.

Here's how to bind to the events:

componentRef.current.addEventListener('contextMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The Context Menu can be disabled by setting the disableContextMenu property to the Smart.Scheduler.

An additional contextMenuClipboardActions boolean property is available that if enabled displays the 'Copy/Cut/Paste' clipboard shortut items as part of the default context menu.

Event Menu

Events inside the Smart.Scheduler timeline can trigger a menu that shows additional information for the target event.

The event information is shown as a Event Menu item. These items actually represent the event objects that correspond to the clicked target but have an additional button that allows to directly delete the event without going through the Scheduler Window.

If an Event Menu item is clicked then the Smart.Scheduler Window will appear allowing to modify the target event.

Here's what the Event Menu looks like for Scheduler timeline events when clicked:

When the click target is an event collector then the Event Menu contains a list of events that are collected. The Event Menu represent a Smart.ScrollViewer and if the events overflow a scrollbar will appear allowing to scroll through them:

The following events are triggered by the Event Menu:

  • eventMenuOpen - fired when the Event Menu is opened.
  • itemClick - fired when a Event Menu Item is clicked. This event contains details regarding the item that was clicked.
  • eventMenuClose - fired when the Event Menu is closed.

Here's how to bind to the events:

componentRef.current.addEventListener('eventMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

Event Menu for specific events can be triggered via the Smart.Scheduler API as well thanks to the following methods:

  • openEventTooltip - opens the Event Menu for specific event if possible. The method takes one argument - a Scheduler event object:
    openEventTooltip(eventObj:EventObj)
  • closeEventTooltip - closes the Event Menu if opened.
    closeEventTooltip()

The Event Menu can be disabled by setting the disableEventMenu property to the Smart.Scheduler.

Smart.Scheduler menus can be styled via CSS variables. Check the Smart.Scheduler API for more details on CSS styling.

For AI tooling

Developer Quick Reference

Topic: scheduler-menus   Component: Scheduler   Framework: React

Main methods: (none detected)

Common config keys: views

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Smart.Scheduler Menus

Scheduler for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.scheduler.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-scheduler ref="component"></smart-scheduler>
</template>

Use component.value for API methods in this topic.

Menus

Smart.Scheduler contains many clickable elements some of which can trigger a popup menu to appear. Depending on the click target the popup can be for date selection, view selection, event editing/creation or a context menu.

A Smart.Tooltip component is used for the menus of the Smart.Scheduler. It has the abbility to reposition itself in order to always be inside the visible area.

Here is a list of the Smart.Scheduler menus:

Date Menu

The Scheduler always shows a date or a range of dates depending on the view. For example, when the view is set to 'day' only one date can be visible. The currently visible date is determined by the dateCurrent property of the Smart.Scheduler. It can be changed via the Date Menu which can be triggered from the date selection control that is located in the header.

When the date selector is clicked the Date Menu appears under it by displaying a Smart.Calendar that allows to pick the view date.

There are two events related to the Date Menu in the Smart.Scheduler:

  • dateMenuOpen - fired when the Date Menu is opened.
  • dateMenuClose - fired when the Date Menu is closed.

Here's how to bind to the events:

component.value.addEventListener('dateMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The Date Menu can be disabled by setting the disableDateMenu property of the Smart.Scheduler.

View Menu

The View Menu is the default choice for view selection. In order to change the current view simply click on the view selector control which is positioned inside the header of the Smart.Scheduler component and the View Menu will open.

However the usage of the View Menu depends on the viewSelectorType property. This property determines whether the view items are positioned inside a menu or as tabs. A third option is also available called 'auto' that allows the Scheduler to automatically determine when to use a menu or tabs control for view selection. The decision is based on the space available inside the header for the views. When the view selector type is set to 'tabs', two additional navigation buttons appear in the view selection area that allow to scroll through the items when necessary.

When the View selector button is clicked the View Menu will appear:

The View Menu items depend on the views property. The views defined in the views property will appear as view items in the View Menu. Custom views can be defined as objects. These views can have custom labels and custom shortcut keys as well.

At the bottom of the View menu there's an additional checkbox item that allows to show/hide the weekends. This property depends on the current view settings. It also depends on the hideWeekend Smart.Scheduler property which hides the weekends for all views. However this property can be applied to specific views as well.

Another cool feature of the View Menu is the view items shortcuts. By default each view item has a shortcut key or key combination that when executed the Smart.Sheduler will switch to the corresponding view. The View seletor button should be focused in order for the shortcuts to work. By default the buttons is focused while the View Menu is opened. These shortcuts can also be modifed in the custom view object definition via the views property. Here's an example of a custom view:

const componentProps = {
            //Properties
            view: 'month',
            nonworkingDays: [0, 3],
            views: [
                {
                    type: 'month',
                    label: 'Custom Month',
                    hideNonworkingWeekdays: true,
                    shortcutKey: 'X'
                },
                {
                    type: 'week',
                    label: 'Custom Week',
                    shortcutKey: 'C+W'
                },
                {
                    type: 'agenda',
                    label: 'Custom Agenda',
                    hideWeekend: true,
                    shortcutKey: 'C+A'
                },
            ]
}; 

There are two events related to the View Menu in the Smart.Scheduler:

  • viewMenuOpen - fired when the View Menu is opened.
  • viewMenuClose - fired when the View Menu is closed.

Here's how to bind to the events:

component.value.addEventListener('viewMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The View Menu can be disabled by setting the disableViewMenu property of the Smart.Scheduler.

Context Menu

Smart.Scheduler has a build in Context Menu that appears on mouse right click (or touch hold for mobile) over a view cell or an event element. The Context Menu contains menu items. Each item has a label and a value. The label is used as the name of the item wihle value represents the action. Smart.Scheduler has two build-in context menu actions: 'createEvent' and 'editEvent'. The items are determined based on the click target. For example 'editEvent' action is only showed when the user opens the Context Menu on events, not on cells. The view cell Context Menu is only used to create new events.

The Context Menu can be customized to contain completely different items that execute other user actions thanks to the contextMenuDataSource property. It accepts an Array of objects with label-value pairs where the label is again used to name the item and value for the action. The Smart.Scheduler will only create the custom context menu items while the custom action handling is left to the user.

Here's how the Context Menu for a view cell appears when opened:

and here's how the Context Menu for an event element appears when opened:

Clicking on one of the items in the default Context Menu will trigger the Scheduler Window to create/edit an event.

The following events are triggered by the Context Menu:

  • contextMenuOpen - fired when the Context Menu is opened.
  • itemClick - fired when a Context Menu Item was clicked. This event contains details regarding the item that is clicked.
  • contextMenuClose - fired when the Context Menu is closed.

Here's how to bind to the events:

component.value.addEventListener('contextMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

The Context Menu can be disabled by setting the disableContextMenu property to the Smart.Scheduler.

An additional contextMenuClipboardActions boolean property is available that if enabled displays the 'Copy/Cut/Paste' clipboard shortut items as part of the default context menu.

Event Menu

Events inside the Smart.Scheduler timeline can trigger a menu that shows additional information for the target event.

The event information is shown as a Event Menu item. These items actually represent the event objects that correspond to the clicked target but have an additional button that allows to directly delete the event without going through the Scheduler Window.

If an Event Menu item is clicked then the Smart.Scheduler Window will appear allowing to modify the target event.

Here's what the Event Menu looks like for Scheduler timeline events when clicked:

When the click target is an event collector then the Event Menu contains a list of events that are collected. The Event Menu represent a Smart.ScrollViewer and if the events overflow a scrollbar will appear allowing to scroll through them:

The following events are triggered by the Event Menu:

  • eventMenuOpen - fired when the Event Menu is opened.
  • itemClick - fired when a Event Menu Item is clicked. This event contains details regarding the item that was clicked.
  • eventMenuClose - fired when the Event Menu is closed.

Here's how to bind to the events:

component.value.addEventListener('eventMenuOpen', function(event) {
    const target = event.detail.target;
    //...
});

Event Menu for specific events can be triggered via the Smart.Scheduler API as well thanks to the following methods:

  • openEventTooltip - opens the Event Menu for specific event if possible. The method takes one argument - a Scheduler event object:
    openEventTooltip(eventObj:EventObj)
  • closeEventTooltip - closes the Event Menu if opened.
    closeEventTooltip()

The Event Menu can be disabled by setting the disableEventMenu property to the Smart.Scheduler.

Smart.Scheduler menus can be styled via CSS variables. Check the Smart.Scheduler API for more details on CSS styling.

For AI tooling

Developer Quick Reference

Topic: scheduler-menus   Component: Scheduler   Framework: Vue

Main methods: (none detected)

Common config keys: views

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with